



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>文本处理命令--wc、sed</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">文本处理命令--wc、sed</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-07 10:01:21 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>一、wc</strong></p>
<p>wc命令的功能为统计指定文件中的字节数、字数、行数，并将统计结果显示输出。</p>
<p><strong>测试文件内容：</strong></p>
<div>
<pre class="prettyprint linenums">(my_python_env)[root@hadoop26 ~]# cat test<br />
hnlinux<br />
peida.cnblogs.com<br />
ubuntu<br />
ubuntu linux<br />
redhat<br />
Redhat<br />
linuxmint</pre>
</div>
<p><strong>1.1最基本的用法</strong></p>
<div>
<pre class="prettyprint linenums">(my_python_env)[root@hadoop26 ~]# wc test<br />
     test</pre>
</div>
<p>其中7代表行数</p>
<p>8是单词书，一个单词被定义为由空格、制表符或者换行符分割的字符串</p>
<p>70是字节数</p>
<p><strong>1.2-l计算行数</strong></p>
<div>
<pre class="prettyprint linenums">(my_python_env)[root@hadoop26 ~]# wc -l test<br />
 test</pre>
</div>
<p><strong>1.3-w计算单词数</strong></p>
<div>
<pre class="prettyprint linenums">(my_python_env)[root@hadoop26 ~]# wc -w test<br />
 test</pre>
</div>
<p><strong>1.4-c计算字节数</strong></p>
<div>
<pre class="prettyprint linenums">(my_python_env)[root@hadoop26 ~]# wc -c test<br />
 test</pre>
</div>
<p><strong>1.5-L打印最长行的长度</strong></p>
<div>
<pre class="prettyprint linenums">(my_python_env)[root@hadoop26 ~]# wc -L test<br />
 test</pre>
</div>
<p><strong>1.6用wc命令怎么做到只打印统计数字不打印文件名？</strong></p>
<p>使用管道可以做到，这在shell脚本中特别有用</p>
<div>
<pre class="prettyprint linenums">(my_python_env)[root@hadoop26 ~]# cat test | wc -l
</pre>
</div>
<p><strong>二、sed</strong></p>
<p>sed 是一种在线编辑器，它一次处理一行内容。处理时，把当前处理的行存储在临时缓冲区中，称为&ldquo;模式空间&rdquo;（pattern space），接着用sed命令处理缓冲区中的内容，处理完成后，把缓冲区的内容送往屏幕。接着处理下一行，这样不断重复，直到文件末尾。文件内容并没有 改变，除非你使用重定向存储输出。Sed主要用来自动编辑一个或多个文件；简化对文件的反复操作；编写转换程序等。</p>
<p><strong>2.1sed的使用参数</strong></p>
<div>
<pre class="prettyprint linenums">[root@www ~]# sed [-nefr] [动作]<br />
选项与参数：<br />
-n ：使用安静(silent)模式。在一般 sed 的用法中，所有来自 STDIN 的数据一般都会被列出到终端上。但如果加上 -n 参数后，则只有经过sed 特殊处理的那一行(或者动作)才会被列出来。<br />
-e ：直接在命令列模式上进行 sed 的动作编辑；<br />
-f ：直接将 sed 的动作写在一个文件内， -f filename 则可以运行 filename 内的 sed 动作；<br />
-r ：sed 的动作支持的是延伸型正规表示法的语法。(默认是基础正规表示法语法)<br />
-i ：直接修改读取的文件内容，而不是输出到终端。

动作说明： [n1[,n2]]function<br />
n1, n2 ：不见得会存在，一般代表『选择进行动作的行数』，举例来说，如果我的动作是需要在 10 到 20 行之间进行的，则『 10,20[动作行为] 』

function：<br />
a ：新增， a 的后面可以接字串，而这些字串会在新的一行出现(目前的下一行)～<br />
c ：取代， c 的后面可以接字串，这些字串可以取代 n1,n2 之间的行！<br />
d ：删除，因为是删除啊，所以 d 后面通常不接任何咚咚；<br />
i ：插入， i 的后面可以接字串，而这些字串会在新的一行出现(目前的上一行)；<br />
p ：列印，亦即将某个选择的数据印出。通常 p 会与参数 sed -n 一起运行～<br />
s ：取代，可以直接进行取代的工作哩！通常这个 s 的动作可以搭配正规表示法！例如 1,20s/old/new/g 就是啦！
</pre>
</div>
<p><strong>2.2d删除</strong></p>
<p>将/etc/passwd的内容列出并且列出行号，同时，将2~5行删除</p>
<div>
<pre class="prettyprint linenums">(my_python_env)[root@hadoop26 ~]# nl /etc/passwd | sed '2,5d'<br />
         root:x:::root:/root:/bin/bash<br />
         sync:x:::sync:/sbin:/bin/sync<br />
         shutdown:x:::shutdown:/sbin:/sbin/shutdown<br />
         halt:x:::halt:/sbin:/sbin/halt<br />
         mail:x:::mail:/var/spool/mail:/sbin/nologin</pre>
</div>
<p>注意sed后面接的动作需要使用单引号</p>
<p>只删除第2行</p>
<div>
<pre class="prettyprint linenums">(my_python_env)[root@hadoop26 ~]# nl /etc/passwd | sed '2d'<br />
         root:x:::root:/root:/bin/bash<br />
         daemon:x:::daemon:/sbin:/sbin/nologin<br />
         adm:x:::adm:/var/adm:/sbin/nologin<br />
         lp:x:::lp:/var/spool/lpd:/sbin/nologin</pre>
</div>
<p>删除第3行到最后一行</p>
<div>
<pre class="prettyprint linenums">(my_python_env)[root@hadoop26 ~]# nl /etc/passwd | sed '3,$d'<br />
         root:x:::root:/root:/bin/bash<br />
         bin:x:::bin:/bin:/sbin/nologin</pre>
</div>
<p><strong>2.3a和i选项的增加</strong></p>
<p>在/etc/passwd第三行增加一行</p>
<div>
<pre class="prettyprint linenums">(my_python_env)[root@hadoop26 ~]# nl /etc/passwd | sed '2a this is a extend row'<br />
         root:x:::root:/root:/bin/bash<br />
         bin:x:::bin:/bin:/sbin/nologin<br />
this is a extend row<br />
         daemon:x:::daemon:/sbin:/sbin/nologin<br />
         adm:x:::adm:/var/adm:/sbin/nologin</pre>
</div>
<p>上面的需求还可以使用-i选项来实现</p>
<div>
<pre class="prettyprint linenums">(my_python_env)[root@hadoop26 ~]# nl /etc/passwd | sed '3i this is a extend row'<br />
         root:x:::root:/root:/bin/bash<br />
         bin:x:::bin:/bin:/sbin/nologin<br />
this is a extend row<br />
         daemon:x:::daemon:/sbin:/sbin/nologin<br />
         adm:x:::adm:/var/adm:/sbin/nologin</pre>
</div>
<p><strong>2.4-c选项的替换</strong></p>
<p>将2~5行的内容替换掉</p>
<div>
<pre class="prettyprint linenums">(my_python_env)[root@hadoop26 ~]# nl /etc/passwd | sed '2,5c 2-5 rows'<br />
         root:x:::root:/root:/bin/bash<br />
- rows<br />
         sync:x:::sync:/sbin:/bin/sync<br />
         shutdown:x:::shutdown:/sbin:/sbin/shutdown</pre>
</div>
<p><strong>2.5-n和-p</strong></p>
<p>仅列出文件的5-7行</p>
<div>
<pre class="prettyprint linenums">(my_python_env)[root@hadoop26 ~]# nl /etc/passwd | sed -n '5,7p'<br />
         lp:x:::lp:/var/spool/lpd:/sbin/nologin<br />
         sync:x:::sync:/sbin:/bin/sync<br />
         shutdown:x:::shutdown:/sbin:/sbin/shutdown</pre>
</div>
<p><strong>2.6数据搜寻</strong></p>
<p>搜索有root关键字的行</p>
<div>
<pre class="prettyprint linenums">(my_python_env)[root@hadoop26 ~]# nl /etc/passwd | sed -n '/root/p'<br />
         root:x:::root:/root:/bin/bash<br />
        operator:x:::operator:/root:/sbin/nologin</pre>
</div>
<p>搜索有root关键字的行，并删除</p>
<div>
<pre class="prettyprint linenums">(my_python_env)[root@hadoop26 ~]# nl /etc/passwd | sed  '/root/d'<br />
         bin:x:::bin:/bin:/sbin/nologin<br />
         daemon:x:::daemon:/sbin:/sbin/nologin<br />
         adm:x:::adm:/var/adm:/sbin/nologin<br />
         lp:x:::lp:/var/spool/lpd:/sbin/nologin</pre>
</div>
<p>数据搜寻+执行命令</p>
<p>搜索/etc/passwd,找到root对应的行，执行后面花括号中的一组命令，每个命令之间用分号分隔，这里把bash替换为blueshell，再输出这行：</p>
<div>
<pre class="prettyprint linenums">(my_python_env)[root@hadoop26 ~]# nl /etc/passwd | sed -n '/root/{s/bash/blueshell/;p}'<br />
         root:x:::root:/root:/bin/blueshell<br />
        operator:x:::operator:/root:/sbin/nologin</pre>
</div>
<p>如果只替换/etc/passwd的第一个bash关键字为blueshell，就退出</p>
<div>
<pre class="prettyprint linenums">(my_python_env)[root@hadoop26 ~]# nl /etc/passwd | sed -n '/root/{s/bash/blueshell/;p;q}'<br />
         root:x:::root:/root:/bin/blueshell</pre>
</div>
<p>最后的q是退出</p>
<p><strong>2.7数据搜寻与替换</strong></p>
<p>除了整行的处理模式之外， sed 还可以用行为单位进行部分数据的搜寻并取代。基本上 sed 的搜寻与替代的与 vi 相当的类似！他有点像这样：</p>
<p>sed 's/要被取代的字串/新的字串/g'</p>
<div>
<pre class="prettyprint linenums">(my_python_env)[root@hadoop26 ~]# /sbin/ifconfig eth0 | grep 'inet addr' | sed 's/^.*addr://g'<br />
192.168.223.129  Bcast:192.168.223.255  Mask:255.255.255.0</pre>
</div>
<p>接下来则是删除后续的部分，亦即： 192.168.1.100 Bcast:192.168.1.255 Mask:255.255.255.0</p>
<div>
<pre class="prettyprint linenums">(my_python_env)[root@hadoop26 ~]#  /sbin/ifconfig eth0 | grep 'inet addr' | sed 's/^.*addr://g' | sed 's/Bcast.*$//g'<br />
192.168.223.129 </pre>
</div>
<p><strong>2.8多点编辑</strong></p>
<p>一条sed命令，删除/etc/passwd第三行到末尾的数据，并把bash替换为blueshell</p>
<div>
<pre class="prettyprint linenums">(my_python_env)[root@hadoop26 ~]# nl /etc/passwd | sed -e '3,$d' -e 's/bash/blueshell/'<br />
         root:x:::root:/root:/bin/blueshell<br />
         bin:x:::bin:/bin:/sbin/nologin</pre>
</div>
<p>-e表示多点编辑，第一个编辑命令删除/etc/passwd第三行到末尾的数据，第二条命令搜索bash替换为blueshell。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9j25gw8.html">JDBC连接实例</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pl6e7q.html">Swift随记</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnyxdz8.html">&lbrack;iOS基础控件 - 6&period;10&period;3&rsqb; DatePicker &amp;amp&semi; UIToolBar</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w6m03q.html">CSS内容</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xy5268.html">Scala中class和object的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm6l1l9.html">Hibernate中的一对多关系详解&lpar;2&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wzwdlq.html">gdb调试memcached</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yoj3n8.html">javascript 简易文本编辑器</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey1ldk9.html">第一章&period; ActionScript 语言基础</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj2xxeq.html">C&sol;C&plus;&plus;知识点清单01</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z0nk59.html">前端部署ant&plus;yuicompressor文件压缩&plus;获取版本&plus;SSH公布（部分代码）</a>
		</li>
						<li><a href="https://www.batexi.com/a/960417y9.html">E - The Balance POJ - 2142  （欧几里德）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q254w5lq.html">flask上传下载文件（一）下载</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppw70d9.html">如何打开Intellij IDEA的代码提示功能&sol;联想&sol;自动联想</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjk25zq.html">Android的相关事件</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rnpwgmq.html">【Java集合的详细研究6】Java 数组</a>
		</li>
						<li><a href="https://www.batexi.com/a/963wwzv9.html">iconv-go升级过程中的编译问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jmyg1e9.html">Python pycurl使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q44mny5q.html">&lbrack;BZOJ4456&rsqb; &lbrack;Zjoi2016&rsqb;旅行者  分治&plus;最短路</a>
		</li>
						<li><a href="https://www.batexi.com/a/96m7e4y8.html">mac 安装 composer</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qlml03e9.html">Eclipse 中使用 ctrl 无法追踪函数的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydy3kgq.html">如何将MVC Areas中的某一个页设为起始页</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjw50z9.html">webstrom配置node环境一张图片说明问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mn27dpq.html">photoshop CS 调整选择区域的大小</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4yjop3q.html">京东校招笔试（C&plus;&plus;方向）编程题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvv2lkyq.html">403 Forbidden</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xgoev8.html">修复：&amp;quot&semi;Failed to start Load Kernel Modules&amp;quot&semi;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxndpxe8.html">WEB 安全之 SQL注入 &amp;lt&semi; 二 &amp;gt&semi; 暴库</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4yjxd3q.html">百度校招面试经历及总结（已发offer）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j0mjrgq.html">SQL语句基础知识</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
